/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

///////////////////////////////////////////////////////////////////////////////
// @doc     CyrFFApi
// @module  Link Implementation | This module contains the implementation of
//          the CECFFLink class.  This class is intended for use as a base class
//          for any item that can be linked in the OpenSTARep interface.
//
///////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////
// Cyrano includes
#include "CECFFLink.h"

///////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////
// @mfunc   The constructor.
CECFFLink::CECFFLink()
{}

///////////////////////////////////////////////////////////////////////////////
// @mfunc   The destructor.

CECFFLink::~CECFFLink()
{}

///////////////////////////////////////////////////////////////////////////////
// @mfunc   This method creates a link between two underlying IStItem interfaces.
//          The parent item is taken from the derived classes registered name.
//          The child is determined from the passed reference.  Calling this
//          method will invalidate any current link path enumeration.
// @parm    Reference to the object to link to.

void CECFFLink::AddLink( CECFFLink* link )
{}

///////////////////////////////////////////////////////////////////////////////
// @mfunc   This method removes a link between two underlying IStItem interfaces.
//          The parent item is taken from the derived classes registered name.
//          The child is determined from the passed reference.  Calling this
//          function will invalidate any current enumeration of link paths.
// @parm    Reference to the object to delete link from.

void CECFFLink::RemoveLink( CECFFLink* link )
{}


///////////////////////////////////////////////////////////////////////////////
// @mfunc   This method returns the full path to the item represented by this
//          class.  Effectively this is a list of folders that will lead to
//          the object in question when traversed down the hierarchy.  The list
//          is '\|' separated as usual.  The first value is the root folder,
//          and also the name of the Project.  The last name is the name of the
//          item.  Any entries in between represent Folder names.
// @rdesc   The separated path to the item.

string CECFFLink::GetLinkPath()
{
    return "";
}

///////////////////////////////////////////////////////////////////////////////
// @mfunc   This method returns a string representing the complete path to an
//          object that has been linked to this one.  Calling this function
//          will invalidate any current enumeration.
// @rdesc   The first link path.
// @xref    <mf CECFFLink::GetLinkPath>,
//          <mf CECFFLink::GetNextLinkPath>
string CECFFLink::GetFirstLinkPath()
{
    return "";
}

///////////////////////////////////////////////////////////////////////////////
// @mfunc   This method returns the next link path in the sequence or an empty
//          string if there are no more linked items.
// @rdesc   The next link path.
// @xref    <mf CyrStlinkImpl::GetFirstLinkPath>,
//          <mf CyrStlinkImpl::GetLinkPath>
string CECFFLink::GetNextLinkPath()
{
    return "";
}

