/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

#ifndef _CECINETINFO_H_
#   define _CECINETINFO_H_
#   ifdef WIN32
#       include <winsock.h>
#   else
#       include <unistd.h>
#       include <netdb.h>
#       include <netinet/in.h>
#       include <sys/socket.h>
#       include <arpa/inet.h>
#   endif
#   include <string>
#   include "definition.h"

class CECInetInfo
{
public:
    CECInetInfo();
    virtual ~CECInetInfo();
    virtual std::string GetIPAddressAsString(const std::string& name="") const;
    virtual long GetIPAddress(const std::string& name="") const;
    virtual std::string GetHostName() const;
};
#endif
