/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

//==================================================================< Pragmas >
#ifdef  WIN32
#  pragma warning(disable : 4514)
#endif  // WIN32


//=================================================================< Includes >
#ifndef __DEFINITION__
#  include "definition.h"
#endif

#ifdef _WIN32
#ifndef _WINDOWS_
#  define   WIN32_LEAN_AND_MEAN
#  define   NOGDICAPMASKS
#  define   NOVIRTUALKEYCODES
#  define   NOWINMESSAGES
#  define   NOWINSTYLES
#  define   NOSYSMETRICS
#  define   NOMENUS
#  define   NOICONS
#  define   NOKEYSTATES
#  define   NOSYSCOMMANDS
#  define   NORASTEROPS
#  define   NOSHOWWINDOW
#  define   OEMRESOURCE
#  define   NOATOM
#  define   NOCLIPBOARD
#  define   NOCOLOR
#  define   NOCTLMGR
#  define   NODRAWTEXT
#  define   NOGDI
#  define   NOKERNEL
#  define   NOUSER
#  define   NONLS
#  define   NOMB
#  define   NOMEMMGR
#  define   NOMETAFILE
#  define   NOMINMAX
#  define   NOMSG
#  define   NOOPENFILE
#  define   NOSCROLL
#  define   NOSERVICE
#  define   NOSOUND
#  define   NOTEXTMETRIC
#  define   NOWH
#  define   NOWINOFFSETS
#  define   NOCOMM
#  define   NOKANJI
#  define   NOHELP
#  define   NOPROFILER
#  define   NODEFERWINDOWPOS
#  define   NOMCX
#  pragma warning(disable : 4201)
#  include <windows.h>
#  pragma warning(default : 4201)
#endif  // _WINDOWS_

OSVERSIONINFO osVersionInfo;
#endif

extern bool ThreadsInitialize();
extern bool ThreadsUninitialize();
extern bool SocketsInitialize();
extern bool SocketsUninitialize();


// Call this function to initialize the Cyrtools library.
bool CyrtoolsInitialize()
{
#ifdef _WIN32
    osVersionInfo.dwOSVersionInfoSize   = sizeof (OSVERSIONINFO);
    osVersionInfo.dwPlatformId          = 0;
    GetVersionEx (&osVersionInfo);
#endif

    return ThreadsInitialize() && SocketsInitialize();
}

// Call this function to uninitialize the Cyrtools library.
bool CyrtoolsUninitialize()
{
    return ThreadsUninitialize() && SocketsUninitialize();
}

#include <new.h>
#include "xalloc.hpp"

//-----------------------------------------------------------------------------
// onMemoryFailure
//
// Memory failure handle.
//
// Arguments : tSize : Request size for new.
// Return    : 0     : Allocation failed.
//-----------------------------------------------------------------------------
int onMemoryFailure (size_t tSize)
{
    throw CTxalloc ("Can't allocate memory ", tSize) ;
    return 0 ;
} // onMemoryFailure
