/* Copyright (C) 2000-2001 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/
// CORBAInfo.h: interface for the CCORBAInfo class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CORBAINFO_H__41AEA3AD_03D2_453C_87CC_1B42E1017824__INCLUDED_)
#define AFX_CORBAINFO_H__41AEA3AD_03D2_453C_87CC_1B42E1017824__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#include <OSTAORB\OSTAORB.h>
#include <TestExecuter.h>
#include <TestManager.h>

struct ScriptSummary 
{
	long	lTaskID;
	long	lActiveUsers;
};

typedef vector <ScriptSummary> ScriptSummaryInfo;

struct TaskGroupSummaryWithTasks 
{
	long				lTaskGroupId;           // Task Group Id
	long			    lCompletedIterations;   // Number of Task Group iterations completed
	long				lRunTime;               // Period for which Task Group has been running (seconds)
	long				lActiveUsers;			// Active users for this task group
	long				lBytes;					// http requests for this task group
	long				lRequests;				// http bytes for this task group
	ScriptSummaryInfo	TaskInfo;				// list of tasks
};

struct TaskGroupSummary 
{
		long    lTaskGroupId;           // Task Group Id
		long    lCompletedIterations;   // Number of Task Group iterations completed
		long    lRunTime;               // Period for which Task Group has been running (seconds)
		long	lActiveUsers;			// Active users for this task group
	};

class CCORBAInfo  
{
public:
	BOOL GetRunFolderName(CString &StrFolder, CString strManagerReg);
	void GetActiveTests(CStringArray& arrTests);
	void StopTest(CString strTest);
	void KillTest(CString strTest);
	BOOL IsTestActive(CString TestName, CString& strReg);
	BOOL StartTaskGroup(TaskGroupStartupInfo& tgStartup, CString strManagerReg);
	BOOL StopTaskGroup(long lTaskGroupID, CString strManagerReg);
	TGExecStatus GetTaskGroupStatus(long lTaskGroupID, CString strManagerReg);
	BOOL GetTaskGroupSummary(long lTaskGroupID, CString strManagerReg,TaskGroupSummary &summary);
	BOOL GetTaskGroupSummaryWithTasks(long lTaskGroupID, CString strManagerReg,TaskGroupSummaryWithTasks &summarywt);
	BOOL GetScriptSummary(long lTaskGroupID, CString strManagerReg, ScriptSummaryInfo &summaryInfo);
	BOOL GetTestSummary(CString strManagerReg,TESnapList &teSnapList);

	
	CCORBAInfo();
	virtual ~CCORBAInfo();


private:
	CORBAServer* m_pCorba;
};

#endif // !defined(AFX_CORBAINFO_H__41AEA3AD_03D2_453C_87CC_1B42E1017824__INCLUDED_)
