/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

/////////////////////////////////////////////////////////////////////////
//
// CECRegistryTools.h
// ------------------
//
//    This is the include file for the CECRegistryTools class
//
//=========================================================================

#if !defined(AFX_REGISTRYTOOLS_H__FBD78072_4E82_11D2_A1BA_00104BC30106__INCLUDED_)
#define AFX_REGISTRYTOOLS_H__FBD78072_4E82_11D2_A1BA_00104BC30106__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000


class CECRegistryTools : public CObject
{
    // Construction
public:
    CECRegistryTools(HKEY hKey = NULL);

    // Attributes
public:
    operator HKEY() const;

    // Operations
public:


    // Implementation
public:
    // Gets the String value of any key in the registry
    CString GetStringValue(HKEY hKeyParent, LPCTSTR lpszKeyName, LPCTSTR lpszField);

    int     SetStringValue  (HKEY hKeyParent, LPCTSTR lpszKeyName, LPCTSTR lpszField ,char* Value ,HKEY BaseKey=HKEY_CURRENT_USER);

    // Detaches the handles from the CRegKey Object
    HKEY Detach();

    // Attaches the handles from the CRegKey Object
    void Attach(HKEY hkey);

    // Recursive deletes the registry key
    LONG DeleteKey(LPCTSTR lpszKey);

    // Opens the Sub Key
    LONG Open(HKEY hKeyParent, LPCTSTR lpszKeyName, REGSAM samDesired = KEY_ALL_ACCESS);

    HKEY    GetHKey ()
    {
        return m_hKey;
    }

    // Destructor
    virtual ~CECRegistryTools();
private:
    // Error reporter
    void ReportError();

    // Deletes the Sub Key
    LONG DeleteSubKey(LPCTSTR lpszSubKey);

    // Closes the Sub Key
    LONG Close();

    // Handle to the CRegKey Object
    HKEY m_hKey;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_REGISTRYTOOLS_H__FBD78072_4E82_11D2_A1BA_00104BC30106__INCLUDED_)

