/* Copyright (C) 2001 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

#if !defined(AFX_CONFIGURATIONDLG_H__0298A273_D4CA_11D4_94C7_00C04F89E392__INCLUDED_)
#define AFX_CONFIGURATIONDLG_H__0298A273_D4CA_11D4_94C7_00C04F89E392__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// ConfigurationDlg.h : header file
//
#include "TestCtrl.h"
#include "CECGridCtrl.h"
#include "resource.h"

class CConfigurationDlg : public CDialog
{
// Construction
public:
	void SetTestActive(CString strReg);
	CConfigurationDlg(CWnd* pParent = NULL);   // standard constructor

	void Activate();
// Dialog Data
	//{{AFX_DATA(CConfigurationDlg)
	enum { IDD = IDD_CONFIGURATION };
	CEdit	m_ctlTestDescription;
	CTestCtrl	m_ctlTestList;
	CString	m_strDescription;
	//}}AFX_DATA

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CConfigurationDlg)
	public:
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation

public:
	CString GetStrReg();
	void StopActiveTest();
	BOOL m_bTestActive;

protected:
	CString m_strReg;

	// Generated message map functions
	//{{AFX_MSG(CConfigurationDlg)
	afx_msg void OnSize(UINT nType, int cx, int cy);
	virtual BOOL OnInitDialog();
	afx_msg void OnChangeDescription();
	afx_msg void OnShowWindow(BOOL bShow, UINT nStatus);
	afx_msg void OnToggleShowruns();
	afx_msg void OnUpdateToggleShowruns(CCmdUI* pCmdUI);
	afx_msg void OnUpdateDeleteselection(CCmdUI* pCmdUI);
	afx_msg void OnDeleteselection();
	afx_msg void OnTimer(UINT nIDEvent);
	//}}AFX_MSG
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnButtonChange(int nRow, int nCol);
	afx_msg void OnSglclkTestList(NMHDR* pNMHDR, LRESULT* pResult);
	DECLARE_MESSAGE_MAP()

	virtual BOOL PreTranslateMessage(MSG* pMsg);
	virtual void OnOK();
	virtual void OnCancel();

private:
	BOOL m_bPropBarVisible;

/////////////
	class CDropTarget : public COleDropTarget
	{
	public:
		CDropTarget(CConfigurationDlg *pDlg):m_pDlg(pDlg)
		{}
		virtual ~CDropTarget()
		{}
	
	protected:
		virtual DROPEFFECT OnDragOver( CWnd* pWnd, COleDataObject* pDataObject, DWORD dwKeyState, CPoint point );
		virtual BOOL OnDrop( CWnd* pWnd, COleDataObject* pDataObject, DROPEFFECT dropEffect, CPoint point );

		CConfigurationDlg *m_pDlg;
	};

	CDropTarget m_DropTarget;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CONFIGURATIONDLG_H__0298A273_D4CA_11D4_94C7_00C04F89E392__INCLUDED_)
