/* Copyright (C) 2001 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

#if !defined(AFX_MONITORSUMMARY_H__39FACE0F_018C_471A_BF5D_CE91AAB878BC__INCLUDED_)
#define AFX_MONITORSUMMARY_H__39FACE0F_018C_471A_BF5D_CE91AAB878BC__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// MonitorSummary.h : header file
//
#include "TestFile.h"
#include "mthread.hpp"
#include <TestManager.h>
#include "resource.h"

const int FirstTaskCol=6;
const int MAX_TASKS=200;

/////////////////////////////////////////////////////////////////////////////
// CMonitorSummary dialog
class CMonitorSummary : public CDialog
{

// Construction
public:
	
	struct taskStatus
	{
		long lTaskGroupId;
		BOOL bEnabled;
		TGExecStatus status;
	};

	BOOL Init(CString strManagerReg, CTestFile* pTestFile);
	CMonitorSummary(CWnd* pParent = NULL);   // standard constructor
	virtual ~CMonitorSummary();

	TESnapList m_snapList;
	CArray<taskStatus,taskStatus> m_TaskStatus;

	CString m_strManagerReg;
	CTestFile* m_pTestFile;
	HANDLE m_hCloseThread;
// Dialog Data
	//{{AFX_DATA(CMonitorSummary)
	enum { IDD = IDD_MON_SUMMARY };
	CListCtrl	m_ctlSummary;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMonitorSummary)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CMonitorSummary)
	virtual BOOL OnInitDialog();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnDestroy();
	afx_msg void OnShowWindow(BOOL bShow, UINT nStatus);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
			
private:
	CString ConvertTimeToString(long duration);
	int m_nMaxUsedTaskCol;
	int m_nTaskGroups;
	CString LookupTargetType(CString strTarget);

	void UpdateSummary();
	int m_nTotalIndex;
    CWinThread* m_pUpdateThread;

	typedef struct {
		CString strName;
		CString strExtension;
	}PluginInfo;

	CList <PluginInfo,PluginInfo&> m_listPlugins;
	int LoadProfileTypes();
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MONITORSUMMARY_H__39FACE0F_018C_471A_BF5D_CE91AAB878BC__INCLUDED_)
