/* Copyright (C) 2001 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/
// TaskMonitorIntervalDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TaskMonitorIntervalDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTaskMonitorIntervalDlg dialog


CTaskMonitorIntervalDlg::CTaskMonitorIntervalDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTaskMonitorIntervalDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTaskMonitorIntervalDlg)
	m_nInterval = 0;
	//}}AFX_DATA_INIT
}


void CTaskMonitorIntervalDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTaskMonitorIntervalDlg)
	DDX_Control(pDX, IDC_INT_SPIN, m_ctlIntervalSpin);
	DDX_Text(pDX, IDC_INTERVAL, m_nInterval);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CTaskMonitorIntervalDlg, CDialog)
	//{{AFX_MSG_MAP(CTaskMonitorIntervalDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTaskMonitorIntervalDlg message handlers

BOOL CTaskMonitorIntervalDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	HKEY hKey;
	if(RegOpenKeyEx(HKEY_CURRENT_USER,"SOFTWARE\\OpenSTA\\TestPlugin\\Settings",0,KEY_READ,&hKey)==ERROR_SUCCESS)
	{
		DWORD dwInterval;
		DWORD dwDataSize = sizeof(DWORD);
		if(RegQueryValueEx(hKey,"Task Monitoring Interval",NULL,NULL,(LPBYTE)&dwInterval,&dwDataSize)== ERROR_SUCCESS)
		{
			m_nInterval =dwInterval;
		}
		else
		{
			m_nInterval = 10;
		}
		RegCloseKey(hKey);
	}

	UpdateData(FALSE);	

    const int nNumAccel = 3;
    UDACCEL arAccel[nNumAccel];
    arAccel[0].nInc = 1;
    arAccel[0].nSec = 2;
    arAccel[1].nInc = 10;
    arAccel[1].nSec = 3;
    arAccel[2].nInc = 100;
    arAccel[2].nSec = 4;

	m_ctlIntervalSpin.SetAccel(nNumAccel,arAccel);
	m_ctlIntervalSpin.SetRange(0,UD_MAXVAL);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CTaskMonitorIntervalDlg::OnOK() 
{
	UpdateData(TRUE);

	HKEY hKey;
	if(RegOpenKeyEx(HKEY_CURRENT_USER,"SOFTWARE\\OpenSTA\\TestPlugin\\Settings",0,KEY_WRITE,&hKey)==ERROR_SUCCESS)
	{
		DWORD dwInterval = m_nInterval;
		DWORD dwDataSize = sizeof(DWORD);

		RegSetValueEx(hKey,"Task Monitoring Interval",0,REG_DWORD,(LPBYTE)&dwInterval,dwDataSize);
		RegCloseKey(hKey);
	}

	CDialog::OnOK();
}
