/* Copyright (C) 2001 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

#if !defined(AFX_RESULTSDLG_H__81F44675_D4E6_11D4_94C7_00C04F89E392__INCLUDED_)
#define AFX_RESULTSDLG_H__81F44675_D4E6_11D4_94C7_00C04F89E392__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// ResultsDlg.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CResultsDlg dialog
#include "XChartCtrl.h"
#include "GraphWnd.h"
#include "Resource.h"

class CResultsDlg : public CDialog
{
// Construction
public:
	CResultsDlg(CWnd* pParent = NULL);   // standard constructor
	virtual ~CResultsDlg();
// Dialog Data
	//{{AFX_DATA(CResultsDlg)
	enum { IDD = IDD_RESULTS };
	CStatic	m_ctlListFrame;
	//}}AFX_DATA

	void Activate();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CResultsDlg)
	public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CResultsDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnDefaultOperation();
	afx_msg void OnShowWindow(BOOL bShow, UINT nStatus);
	afx_msg void OnDeleteRuns();
	afx_msg void OnCascade();
	afx_msg void OnTilehorizontally();
	afx_msg void OnTilevertically();
	afx_msg void OnToggleShowruns();
	afx_msg void OnUpdateToggleShowruns(CCmdUI* pCmdUI);
	afx_msg void OnCloseall();
	//}}AFX_MSG
	virtual void OnOK();
	virtual void OnCancel();
	afx_msg void OnUpdateDefOperation(CCmdUI *pCmdUI);
	afx_msg BOOL OnEraseBkgnd(CDC *pDC);
	afx_msg LRESULT OnMDIStateChanged(WPARAM wParam,LPARAM lParam);
	afx_msg LRESULT OnGraphSelChanged(WPARAM,LPARAM);
	DECLARE_MESSAGE_MAP()

	CList <CXChartCtrl*,CXChartCtrl*> m_listCharts;

	CString m_strTestFolder;

	int m_nLastGraphAdded;

	typedef struct 
	{
		CString strRun;
		CString strName;
		CString strPlugin;
		CString strDefOpName;
		BOOL bHasDefOperation;
		CGraphWnd *pGraphWnd;
	}OpenGraph;

	CArray <OpenGraph,OpenGraph> m_arOpenGraphs;
	BOOL GetCurrentGraph(OpenGraph &OG);

	CGraphWnd *m_pCurrentGraph;

	CGraphWnd *AddNewChild(const CString& strTitle);
	CMDIFrameWnd *m_pFrame;
	BOOL m_bRunsVisible;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_RESULTSDLG_H__81F44675_D4E6_11D4_94C7_00C04F89E392__INCLUDED_)
