/* Copyright (C) 2000-2001 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/
#if !defined(AFX_TESTRUNDLG_H__81F4AD13_2A78_11D5_94E9_00C04F89E392__INCLUDED_)
#define AFX_TESTRUNDLG_H__81F4AD13_2A78_11D5_94E9_00C04F89E392__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// TestRunDlg.h : header file
//

#include "OstaDefs.h"
/////////////////////////////////////////////////////////////////////////////
// CTestRunBar dialog
class CTestRunBar : public CSizingControlBarG
{
// Construction
public:
	CTestRunBar(CWnd* pParent = NULL);   // standard constructor

	CTreeCtrl	m_ctlTestRunTree;

	void Refresh();
	void SetTestFolder(const CString& strFolder);
	void SetCheck(const CString& strRun,const CString& strGraph,bool bCheck);
	void SetNotifyWindow(HWND hWnd){m_hwndNotify = hWnd;}

	typedef struct
	{
		CString strTestRun;
		CString strGraph;
		CString strPlugin;
	}NM_TESTRUN;	

	static const CString m_strAuditLogName;
	static const CString m_strHistoryLogName;
	static const CString m_strReportLogName;
	static const CString m_strSummaryName;

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CTestRunBar)
	//}}AFX_VIRTUAL

	typedef struct
	{
		GraphInfo GI;
		CString strPlugin;	//Plugin name
	}GraphType;

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CTestRunBar)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnItemexpandingTestrunTree(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnSelchangedTestrunTree(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnClickTestrunTree(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnRClickTestrunTree(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDestroy();
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

	CString m_strTestFolder;
	HWND m_hwndNotify;
	CImageList m_ImageList;

	HTREEITEM FindTreeItem(const CString& strName,HTREEITEM hParent);

	void SaveBranchState(HTREEITEM hBranch,const CString& strFolder,CMap <CString,LPCTSTR,UINT,UINT>&);
	void RestoreBranchState(HTREEITEM hBranch,const CString& strFolder,CMap <CString,LPCTSTR,UINT,UINT>&);

	static int CompareTestRunName( const void *arg1, const void *arg2 );

};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_TESTRUNDLG_H__81F4AD13_2A78_11D5_94E9_00C04F89E392__INCLUDED_)
