/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// RepositoryAPI.cpp: implementation of the CRepositoryAPI class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "concertlib.h"
#include "ConstantesLib.h"
#include "RepositoryAPI.h"
#include "RegFunctions.h"
#include "OstaDefs.h"

#pragma warning( disable : 4786 )
#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

#pragma warning( disable : 4786 )

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
//--------------------------------------------------------------------

CRepositoryAPI::CRepositoryAPI()
{
//    m_pServer = new CYRServer;
}

//--------------------------------------------------------------------

CRepositoryAPI::~CRepositoryAPI()
{
    DisConnect() ;
//    delete m_pServer;
//    m_pServer = NULL;
}

//--------------------------------------------------------------------

void CRepositoryAPI::SetWindow(CWnd* _pWnd)
{
    m_pWnd = _pWnd;
}

//--------------------------------------------------------------------

BOOL CRepositoryAPI::Connect( const TCHAR* pczUser , const TCHAR* pczPwd )
{
    return true;
}

//--------------------------------------------------------------------

void CRepositoryAPI::DisConnect()
{
//    if( m_pServer )
 //       m_pServer->CloseProject();
}

//--------------------------------------------------------------------

BOOL CRepositoryAPI::IsConnected()
{
//    if( m_pServer )
//        return TRUE ;
//    else
        return FALSE ;
}

//--------------------------------------------------------------------

long CRepositoryAPI::GetProjectCaptureFiles(CStringArray& arstrFileList  )
{
	arstrFileList.RemoveAll();
	CString strReposPath = GetRepositoryPath();
	CString strPath = strReposPath + strScriptType;

	CFileFind FF;
	if(FF.FindFile(strPath + "\\*" + STR_SCL_EXTENSION))
	{
		BOOL bContinue = true;
		while(bContinue)
		{
			bContinue = FF.FindNextFile();
			if(!FF.IsDirectory())
			{
				//If there is an .all file we can add this to the tree
				CFileStatus fs;
				if(CFile::GetStatus(strReposPath+strCaptureFolder + "\\" + FF.GetFileTitle() + ".ALL",fs))
				{
					arstrFileList.Add(FF.GetFilePath());
				}
			}
		}
	}
    return arstrFileList.GetSize();
}

//--------------------------------------------------------------------

void CRepositoryAPI::AddProjectCaptureFiles(const CString& strSCLFile )
{
}


//--------------------------------------------------------------------

BOOL CRepositoryAPI::RetrieveProjectCaptureFiles(const CString& strRepositoryFileName)
{
    return TRUE;
}


//--------------------------------------------------------------------

BOOL CRepositoryAPI::SaveProjectCaptureFiles(const CString& strSCLFileName, bool bRelease )
{
    return TRUE;
}

//--------------------------------------------------------------------

void CRepositoryAPI::DisplayMessage( UINT nID , const CString& strText )
{
    CString strError ;
    CString strMessage ;
    //---
    strError.LoadString( IDS_ERROR_LIB ) ;
    strMessage.Format( nID , strText ) ;
    m_pWnd->MessageBox(strMessage , strError , MB_OK ) ;
}

//--------------------------------------------------------------------

void CRepositoryAPI::DisplayMessage( UINT nID )
{
    CString strError ;
    CString strMessage ;
    //---
    strError.LoadString( IDS_ERROR_LIB ) ;
    strMessage.LoadString( nID ) ;
    m_pWnd->MessageBox( strMessage , strError , MB_OK ) ;
}

//--------------------------------------------------------------------

BOOL CRepositoryAPI::AddFVR(const CString& strSCLFile)
{
    return true;
}

//--------------------------------------------------------------------

BOOL CRepositoryAPI::CheckOutFVR(const CString& strSCLFile)
{
    return true;
}

//--------------------------------------------------------------------

BOOL CRepositoryAPI::CheckInFVR(const CString& strSCLFile)
{
    return true;
}

//--------------------------------------------------------------------

void CRepositoryAPI::GetImpactProjectList(CStringArray& arstrProjectList)
{
}

//--------------------------------------------------------------------

long CRepositoryAPI::GetProjectTemplateFiles(CStringArray& arstrFileList)
{
	arstrFileList.RemoveAll();
	CString strReposPath = GetRepositoryPath();
	CString strPath = strReposPath + strScriptType;

	CFileFind FF;
	if(FF.FindFile(strPath + "\\*.*"))
	{
		BOOL bContinue = true;
		while(bContinue)
		{
			bContinue = FF.FindNextFile();
			if(!FF.IsDirectory())
			{
				CString strPath = FF.GetFilePath();

				CString strExt;
				int nDotPos  = strPath.ReverseFind('.');
				if(nDotPos != -1)
					strExt = strPath.Mid(nDotPos);

				if((strExt.CompareNoCase(STR_SCL_EXTENSION)==0) ||
					(strExt.CompareNoCase(STR_INC_EXTENSION)==0))
				{
					arstrFileList.Add(FF.GetFilePath());
				}
			}
		}
	}

	if(FF.FindFile(strPath + "\\Include\\*.*"))
	{
		BOOL bContinue = true;
		while(bContinue)
		{
			bContinue = FF.FindNextFile();
			if(!FF.IsDirectory())
			{
				CString strPath = FF.GetFilePath();

				CString strExt;
				int nDotPos  = strPath.ReverseFind('.');
				if(nDotPos != -1)
					strExt = strPath.Mid(nDotPos);

				if((strExt.CompareNoCase(STR_SCL_EXTENSION)==0) ||
					(strExt.CompareNoCase(STR_INC_EXTENSION)==0))
				{
					arstrFileList.Add(FF.GetFilePath());
				}
			}
		}
	}
    return arstrFileList.GetSize();
}

//--------------------------------------------------------------------

BOOL CRepositoryAPI::SaveProjectTemplateFiles(const CString& strSCLFileName, bool bRelease )
{
    return true;
}

//--------------------------------------------------------------------

void CRepositoryAPI::AddProjectTemplateFiles(const CString& strSCLFile )
{
    
}

//--------------------------------------------------------------------

BOOL CRepositoryAPI::RetrieveProjectTemplateFiles(const CString& strRepositoryFileName)
{
    return TRUE;
}

//--------------------------------------------------------------------

BOOL CRepositoryAPI::DeleteObjectFiles()
{
	return TRUE;
}

//--------------------------------------------------------------------

BOOL CRepositoryAPI::OpenProject(const CString& strProject)
{
    return true;
}
