/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// ModellerHTMLView.cpp : implementation file
//

#include "stdafx.h"
#include "modeller.h"
#include "VariousObject.h"
#include "ModellerHTMLView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#include "Constantes.h"

// helper for reliable and small Release calls
//DWORD AFXAPI _AfxRelease(LPUNKNOWN* plpUnknown);

//#ifndef _DEBUG

// generate smaller code in release build
//#define RELEASE(lpUnk) _AfxRelease((LPUNKNOWN*)&lpUnk)
//#else

// generate larger but typesafe code in debug build
#define RELEASE(lpUnk) do \
{ if ((lpUnk) != NULL) { (lpUnk)->Release(); (lpUnk) = NULL; } } while (0)
//#endif


/////////////////////////////////////////////////////////////////////////////
// CModellerHTMLView
//---------------------------------------------------------------------------

IMPLEMENT_DYNCREATE(CModellerHTMLView, CHtmlView)

//---------------------------------------------------------------------------

CModellerHTMLView::CModellerHTMLView()
{}

//---------------------------------------------------------------------------


CModellerHTMLView::~CModellerHTMLView()
{}

//---------------------------------------------------------------------------


BEGIN_MESSAGE_MAP(CModellerHTMLView, CHtmlView)
//{{AFX_MSG_MAP(CModellerHTMLView)
ON_WM_LBUTTONDBLCLK()
ON_WM_LBUTTONDOWN()
ON_WM_LBUTTONUP()
ON_WM_DESTROY()
//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CModellerHTMLView drawing
//---------------------------------------------------------------------------

void CModellerHTMLView::OnDraw(CDC* pDC)
{
    CDocument* pDoc = GetDocument();
    // TODO: add draw code here
}

/////////////////////////////////////////////////////////////////////////////
// CModellerHTMLView diagnostics
//---------------------------------------------------------------------------


#ifdef _DEBUG
void CModellerHTMLView::AssertValid() const
{
    CHtmlView::AssertValid();
}

//---------------------------------------------------------------------------

void CModellerHTMLView::Dump(CDumpContext& dc) const
{
    CHtmlView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CModellerHTMLView message handlers
//---------------------------------------------------------------------------

void CModellerHTMLView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint)
{
    if( lHint == ID_DISPLAY_PRIMARY_URL )
    {
        BOOL bRet = GetOffline() ;
        Navigate(((CStringObject*)pHint)->m_strObject ) ;
    }
    else
        CHtmlView::OnUpdate(pSender, lHint, pHint);

}

//---------------------------------------------------------------------------

void CModellerHTMLView::OnInitialUpdate()
{
    CHtmlView::OnInitialUpdate();
    VARIANT_BOOL bOffLine = VARIANT_TRUE ;

    m_pBrowserApp->put_Offline( bOffLine );
}

//---------------------------------------------------------------------------

void CModellerHTMLView::OnLButtonDblClk(UINT nFlags, CPoint point)
{
    // TODO: Add your message handler code here and/or call default

    CHtmlView::OnLButtonDblClk(nFlags, point);
}

//---------------------------------------------------------------------------

void CModellerHTMLView::OnLButtonDown(UINT nFlags, CPoint point)
{
    // TODO: Add your message handler code here and/or call default

    CHtmlView::OnLButtonDown(nFlags, point);
}

//---------------------------------------------------------------------------

void CModellerHTMLView::OnLButtonUp(UINT nFlags, CPoint point)
{
    // TODO: Add your message handler code here and/or call default

    //CHtmlView::OnLButtonUp(nFlags, point);
}


void CModellerHTMLView::OnDestroy()
{
    CView::OnDestroy();
    RELEASE(m_pBrowserApp);
}
