/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// OSGridCtrl.cpp: implementation of the COSGridCtrl class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "OSGridCtrl.h"

/////////////////////////////////////////////////////////////////////////////
// COSGridCtrl
//--------------------------------------------------------------------------

BEGIN_MESSAGE_MAP(COSGridCtrl, CECGridCtrl)
//{{AFX_MSG_MAP(COSGridCtrl)
//}}AFX_MSG_MAP
END_MESSAGE_MAP()

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

COSGridCtrl::COSGridCtrl()
{
    m_nLastDataRow=0;
}

//---------------------------------------------------------------------------

COSGridCtrl::~COSGridCtrl()
{
}

//---------------------------------------------------------------------------


BOOL COSGridCtrl::Create( CWnd * pParent , UINT   nAreaID,
                          UINT   nGridCtrlID, int   nHiddenCols  )
{
    ASSERT( pParent != NULL && pParent->IsKindOf(RUNTIME_CLASS(CWnd)) ) ;
    ASSERT( nAreaID != 0 ) ;
    ASSERT( nGridCtrlID != 0 ) ;

    CStatic * pStatic = static_cast<CStatic *>( pParent->GetDlgItem(nAreaID) ) ;
    // ----
    ASSERT( pStatic != NULL && pStatic->IsKindOf(RUNTIME_CLASS(CWnd)) ) ;

    //m_wHiddenCols       = wHiddenCols ;
    //m_nResHeaderString = nGridCtrlID ; // IDC == IDS

    CRect rc ;
    pStatic->GetWindowRect( &rc ) ;
    pParent->ScreenToClient( &rc ) ;

    //m_nTotalSize = rc.Width() ;

    pStatic->ShowWindow( SW_HIDE ) ;

    //m_bDrawSunken = TRUE ;
    if ( CECGridCtrl::Create( rc, pParent, nGridCtrlID ) )
    {
        /*
        CRect rc2 ;
        pParent->GetClientRect( &rc2 ) ;
        m_ParentClientSize = CSize( rc2.Width() , rc2.Height() ) ;
         */
        return TRUE ;
    }

    return FALSE ;
}

//---------------------------------------------------------------------------

BOOL COSGridCtrl::SetValueRowCol( int nRow, int nCol, CString strValue )
{
    return SetItemText( nRow , nCol, strValue );
}

//---------------------------------------------------------------------------

void COSGridCtrl::GetValueRowCol( int nRow, int nCol, CString & strValue )
{
    strValue.Empty() ;

    strValue = GetItemText( nRow , nCol );
}

//---------------------------------------------------------------------------
BOOL COSGridCtrl::GetFirstSelectedRow( int & nRow )
{
    int nValue ;
    BOOL bOk ;

    nValue = GetSelectedCellRange().GetMinRow();

    bOk = ( nValue != -1 ) ;

    if( bOk ) nRow = nValue ;

    return bOk;
}

//---------------------------------------------------------------------------

BOOL COSGridCtrl::Create( const RECT& rect, CWnd* parent,
                          UINT nID, DWORD dwStyle )
{
    return CECGridCtrl::Create( rect, parent, nID, dwStyle );
}

