/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// ScriptItemInfo.h: interface for the CScriptItemInfo class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SCRIPTITEMINFO_H__D6BDB60A_0DA9_4DEB_AB40_9F1BDBBB078F__INCLUDED_)
#define AFX_SCRIPTITEMINFO_H__D6BDB60A_0DA9_4DEB_AB40_9F1BDBBB078F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CScriptItemInfo  
{
public:
	typedef enum {enRequest,enVariable,enTimer,enComment} ScriptItemType;

	CScriptItemInfo(ScriptItemType nType,int nStartLine,int nEndLine);
	virtual ~CScriptItemInfo();

	void SetStartLine(int nLine){m_nStartLine = nLine;}
	void SetNumLines(int nNumLines){m_nNumLines= nNumLines;}
	int GetStartLine() const {return m_nStartLine;}
	int GetNumLines() const {return m_nNumLines;}
	int GetLastLine() const {return m_nStartLine + m_nNumLines-1;}
	ScriptItemType GetItemType() const {return m_nItemType;}

#ifdef _DEBUG
	virtual void Dump() const;
#endif

private:
	ScriptItemType m_nItemType;
	int m_nNumLines;
	int m_nStartLine;
};

#endif // !defined(AFX_SCRIPTITEMINFO_H__D6BDB60A_0DA9_4DEB_AB40_9F1BDBBB078F__INCLUDED_)
