/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

///////////////////////////////////////////////////////////////////////////////
// @doc NT_Performance
///////////////////////////////////////////////////////////////////////////////

#ifndef _OtaNTPerf_h
#define _OtaNTPerf_h


///////////////////////////////////////////////////////////////////////////////
// Standard includes
#include <string>
using std::string;
#include <pdh.h>

#include <vector>
using std::vector;
#pragma warning(disable:4786)
#pragma warning(disable:4503)

///////////////////////////////////////////////////////////////////////////////
// @type CounterArray | This list contains a collection of counter handles
typedef vector<HCOUNTER>  CounterArray;

class OtaNTPerform
{
    // @access Public Members
public:
    OtaNTPerform();                                 // @cmember Constructor
    virtual ~OtaNTPerform();                        // @cmember Destructor

    // @access IDL Generated Methods
    bool RunSimpleQuery( const string query, long *result );       // @cmember Runs simple query
    bool ExecQuery( const string query, long *result );       // @cmember Runs simple query
    void LogPDHError (const string func, const string query, PDH_STATUS error);
	long GetLastVal();
    // @access Private Members
private:
    CounterArray m_hCounters;                       // Query counter handles
    bool m_initialized;                             // True if initialized
	long m_lastVal;
}
;

#endif
