// EditQueryDlg.cpp : implementation file
//

#include "stdafx.h"
#include "snmpplugin.h"
#include "EditQueryDlg.h"
#include "QueryEditDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEditQueryDlg dialog


CEditQueryDlg::CEditQueryDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CEditQueryDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CEditQueryDlg)
	m_strName = _T("");
	m_strQuery = _T("");
	m_bDelta = FALSE;
	m_strInterval = _T("");
	m_strPort = _T("");
	m_strServer = _T("");
	//}}AFX_DATA_INIT
}


void CEditQueryDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEditQueryDlg)
	DDX_Control(pDX, IDC_SERVER, m_ctlServer);
	DDX_Control(pDX, IDC_INTERVAL_SPIN, m_ctlIntervalSpin);
	DDX_Text(pDX, IDC_NAME, m_strName);
	DDX_Text(pDX, IDC_QUERY, m_strQuery);
	DDX_Check(pDX, IDC_DELTA_VALUE, m_bDelta);
	DDX_Text(pDX, IDC_INTERVAL, m_strInterval);
	DDX_Text(pDX, IDC_PORT, m_strPort);
	DDX_CBString(pDX, IDC_SERVER, m_strServer);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CEditQueryDlg, CDialog)
	//{{AFX_MSG_MAP(CEditQueryDlg)
	ON_BN_CLICKED(IDC_BROWSE_QUERIES, OnBrowseQueries)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEditQueryDlg message handlers

BOOL CEditQueryDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	for(int n=0;n<m_arstrServers.GetSize();n++)
		m_ctlServer.AddString(m_arstrServers[n]);

	if(m_strName.IsEmpty())
	{
		int nNdx=1;
		bool bContinue=true;
		while(bContinue)
		{
			bContinue= false;
			m_strName.Format("Query %d",nNdx++);
			for(int nName=0;nName<m_arstrNamesInUse.GetSize();nName++)
			{
				if(m_arstrNamesInUse[nName] == m_strName)
				{
					bContinue=true;
					break;
				}	
			}	
		}
	}

	UDACCEL AL[2];
	AL[0].nInc = 1;
	AL[0].nSec = 2;
	AL[1].nInc = 3;
	AL[1].nSec = 4;
	m_ctlIntervalSpin.SetAccel(2,AL);
	m_ctlIntervalSpin.SetRange(0,32000);

	UpdateData(FALSE);

	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CEditQueryDlg::OnOK() 
{
	UpdateData();

	m_strName.TrimRight();
	m_strName.TrimLeft();
	if(m_strName.IsEmpty())
	{
		AfxMessageBox("Please enter a name for this query");
		return;
	}

	for(int n=0;n<m_arstrNamesInUse.GetSize();n++)
	{
		if(m_strName == m_arstrNamesInUse[n])
		{
			AfxMessageBox("The name of this query is already in use.\nPlease enter a name which is unique within this profile.");
			return;
		}
	}

	if(m_strQuery.IsEmpty())
	{
		AfxMessageBox("Please enter a query");
		return;
	}
	if(m_strInterval.IsEmpty())
	{
		AfxMessageBox("Please enter an interval");
		return;
	}
	if(m_strPort.IsEmpty())
	{
		AfxMessageBox("Please enter a port");
		return;
	}
	if(m_strServer.IsEmpty())
	{
		AfxMessageBox("Please enter a server");
		return;
	}


	CDialog::OnOK();
}

void CEditQueryDlg::EditQuery()
{
	UpdateData();

	if (m_strServer.IsEmpty())
	{
		MessageBox("Please select a server.", "OpenSTA", MB_ICONEXCLAMATION);
		return;
	}

	CQueryEditDlg dlg(m_strServer, m_strQuery, atoi(m_strPort));
	if(dlg.DoModal()==IDOK)
	{
		m_strQuery = dlg.GetQuery();
		UpdateData(FALSE);
	}
}


void CEditQueryDlg::OnBrowseQueries() 
{
	EditQuery();	
}
